#property copyright "Spectrum TA (c) HotFx 2011.08.16"
#property link "http://hot-fx.blogspot.com" // http://hotfx.0pk.ru

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_level1 0
#property indicator_levelcolor Gold

extern int Per            = 7;
extern int Num            = 8;
extern string SoundTrend  = "tick.wav";

bool bTR = TRUE, sTR = TRUE;
int mod = MODE_SMA, typ = PRICE_CLOSE, maxNum = 8, p1, p2, p4, p8, p16, p32, p64, p128;
double x1, x2, x4, x8, x16, x32, x64, x128, divPer, cup[], cdn[], up[], dn[], ueq[], deq[], b[], s[], sBuy, sSel, ob, os, sum, ol;
string info;

void init()
 {
  if (Per < 1) Per = 1;
  if (Num < 1) Num = 1;
  if (Num > maxNum) Num = maxNum;
  divPer = Per / MathPow(2, (maxNum - Num)); info =" (";
  p128 = MathRound(divPer * 128); info = info + p128;
  if (Num > 1) { p64 = MathRound(divPer * 64); info = info + "-" + p64; }
  if (Num > 2) { p32 = MathRound(divPer * 32); info = info + "-" + p32; }
  if (Num > 3) { p16 = MathRound(divPer * 16); info = info + "-" + p16; }
  if (Num > 4) {  p8 = MathRound(divPer *  8); info = info + "-" + p8;  }
  if (Num > 5) {  p4 = MathRound(divPer *  4); info = info + "-" + p4;  }
  if (Num > 6) {  p2 = MathRound(divPer *  2); info = info + "-" + p2;  }
  if (Num > 7) {  p1 = MathRound(divPer *  1); info = info + "-" + p1;  }
  info = info + ")";
  SetIndexBuffer(0,  up);  SetIndexStyle(0, DRAW_HISTOGRAM, EMPTY, 5, Navy);
  SetIndexBuffer(1,  dn);  SetIndexStyle(1, DRAW_HISTOGRAM, EMPTY, 5, FireBrick);
  SetIndexBuffer(2,  ueq); SetIndexStyle(2, DRAW_HISTOGRAM, EMPTY, 5, FireBrick);
  SetIndexBuffer(3,  deq); SetIndexStyle(3, DRAW_HISTOGRAM, EMPTY, 5, Navy);
  SetIndexBuffer(4,  b);   SetIndexStyle(4, DRAW_ARROW, EMPTY, EMPTY, Blue);      SetIndexArrow(4, 159);
  SetIndexBuffer(5,  s);   SetIndexStyle(5, DRAW_ARROW, EMPTY, EMPTY, Red);       SetIndexArrow(5, 159);
  SetIndexBuffer(6,  cup); SetIndexStyle(6, DRAW_ARROW, EMPTY, 1, Aqua);          SetIndexArrow(6, 159);
  SetIndexBuffer(7,  cdn); SetIndexStyle(7, DRAW_ARROW, EMPTY, 1, Magenta);       SetIndexArrow(7, 159);
 }

void start()
 {
  int limit = Bars - 1 - IndicatorCounted();
  for (int i = limit ; i > 0; i --)  
   {
    sBuy = 0; sSel = 0; sum = 0;
    x128 = iMA(NULL, 0, p128, 0, mod, typ, i);
    if (Num > 1)
     { 
      x64 = iMA(NULL, 0, p64, 0, mod, typ, i); sum = x64 - x128;
      if (x64 > x128) sBuy = sBuy + (x64 - x128);
      if (x64 < x128) sSel = sSel + (x64 - x128);
     }
    if (Num > 2)
     {
      x32 = iMA(NULL, 0, p32, 0, mod, typ, i); sum = x32 - x128;
      if (x32 > x64) sBuy = sBuy + (x32 - x64);
      if (x32 < x64) sSel = sSel + (x32 - x64);
     }
    if (Num > 3)
     {
      x16 = iMA(NULL, 0, p16, 0, mod, typ, i); sum = x16 - x128;
      if (x16 > x32) sBuy = sBuy + (x16 - x32);
      if (x16 < x32) sSel = sSel + (x16 - x32);
     }
    if (Num > 4)
     {
      x8 = iMA(NULL, 0,  p8, 0, mod, typ, i); sum = x8 - x128;
      if (x8 > x16) sBuy = sBuy + (x8 - x16);
      if (x8 < x16) sSel = sSel + (x8 - x16);
     }
    if (Num > 5)
     {
      x4 = iMA(NULL, 0,  p4, 0, mod, typ, i); sum = x4 - x128;
      if (x4 > x8) sBuy = sBuy + (x4 - x8);
      if (x4 < x8) sSel = sSel + (x4 - x8);
     }
    if (Num > 6)
     {
      x2 = iMA(NULL, 0,  p2, 0, mod, typ, i); sum = x2 - x128;
      if (x2 > x4) sBuy = sBuy + (x2 - x4);
      if (x2 < x4) sSel = sSel + (x2 - x4);
     }
    if (Num > 7)
     {
      x1 = iMA(NULL, 0,  p1, 0, mod, typ, i); sum = x1 - x128;
      if (x1 > x2) sBuy = sBuy + (x1 - x2);
      if (x1 < x2) sSel = sSel + (x1 - x2);
     }

    if (sum > ol) b[i] = sum;
    if (sum < ol) s[i] = sum;

    if (sBuy > ob)
     {
      up[i] = sBuy;
      if ((sSel > os) || (sSel == 0))
       {
        cup[i] = sBuy;
        if (sBuy > -sSel)  IndicatorShortName(info + "     BUY");
        else IndicatorShortName(info + "     buy");
        if (bTR && (SoundTrend!="") && (i == 1)) { PlaySound(SoundTrend); bTR = FALSE; }
       } 
     } 
    else ueq[i] = sBuy;

    if (cup[i] != sBuy) bTR = TRUE;

     
    if (sSel < os)
     {
      dn[i] = sSel;
      if ((sBuy < ob) || (sBuy == 0))
       {
        cdn[i] = sSel;
        if (-sSel > sBuy)  IndicatorShortName(info + "     SELL");
        else IndicatorShortName(info + "     sell");
        if (sTR && (SoundTrend!="") && (i == 1)) { PlaySound(SoundTrend); sTR = FALSE; }
       } 
     }  
    else deq[i] = sSel;

    if (cdn[i] != sSel) sTR = TRUE;
    
    
    if ( ((sSel < os) && (sBuy > ob)) || ((sSel > os) && (sBuy < ob)) ) IndicatorShortName(info + "     F-L-A-T");

    os = sSel; ob = sBuy; ol = sum;
   }

 } //start

